//
// UNIVERSAL LIST CLASS
//
// Written and Revised by Akihiro Tsutsui (NTT Optical Network Systems Labs.)
// Copyright (c) 1994, 1995 Nippon Telegraph & Telephone Corporation

#ifndef _ulist_h_
#define _ulist_h_ 1

#include "glist.h"

template<class T>
class ulist : public glist {

	public :

	glink*	append(T val) { return glist::append((void*) val); }
	T		remove(glink* gl) { return (T) glist::remove(gl) ;}
	T		getval() { return (T) glist::getval() ;}
	T		get_first() { return (T) glist::get_first() ;}
	T		get_last()  { return (T) glist::get_last()  ;}
};

#define forall_list_links(a,b)\
for ((b).gohead(); a = (b).getcur(); (b).succur())
#define forall_list_items(a,b)\
for ((b).gohead(); (a = (b).getval()) || (b).getcur(); (b).succur())
#define forall_plist_links(a,b)\
for ((b)->gohead(); a = (b)->getcur(); (b)->succur())
#define forall_plist_items(a,b)\
for ((b)->gohead(); (a = (b)->getval()) || (b)->getcur(); (b)->succur())

#endif
